unit UCCode;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ISourceCode1, StdCtrls, Buttons;

type
  TUCCodeForm = class(TForm)
    edtTitle: TEdit;
    memoSummary: TMemo;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    btnClose: TBitBtn;
    btnSource: TBitBtn;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnSourceClick(Sender: TObject);
  private
    SourceCode: ISourceCode;
  end;

var
  UCCodeForm: TUCCodeForm = nil;

implementation
uses
  SoapHttpTrans, InvokeRegistry;

{$R *.dfm}

procedure TUCCodeForm.FormCreate(Sender: TObject);
begin
  SourceCode := GetISourceCode;
  ScrollBar1.Min := 1;
  try
    ScrollBar1.Max := SourceCode.LatestIssue;
  except
    on E: ESOAPHTTPException do
      // connection could not be established - try again ;-)
      ScrollBar1.Max := SourceCode.LatestIssue
  end;
  ScrollBar1.Position := ScrollBar1.Max;
  Caption := 'Under Construction in issues #1..#' + IntToStr(ScrollBar1.Max)
end;

procedure TUCCodeForm.ScrollBar1Change(Sender: TObject);
var
  Title, Summary: WideString;
  Source: Integer;
begin
  with Sender as TScrollBar do
  try
    Label1.Caption := '#' + IntToStr(Position);
    SourceCode.UnderConstruction(Position, Title, Summary, Source)
  except
    on E: ESOAPHTTPException do
      // connection could not be established - try again ;-)
      SourceCode.UnderConstruction(Position, Title, Summary, Source)
  end;
  edtTitle.Text := Title;
  memoSummary.Text := Summary;
  Label2.Caption := Format('%d Bytes', [Source]);
  Label2.Visible := Source > 0;
  btnSource.Enabled := Source > 0;
end;

procedure TUCCodeForm.btnSourceClick(Sender: TObject);
var
  SoapAttachment: TSoapAttachment;
begin
  SoapAttachment := nil;
  try
    try
      SoapAttachment := SourceCode.GetSourceCode(ScrollBar1.Position);
    except
      on E: ESOAPHTTPException do
        // connection could not be established - try again ;-)
        SoapAttachment := SourceCode.GetSourceCode(ScrollBar1.Position);
    end;
    with TSaveDialog.Create(nil) do
    try
      FileName := Format('constr%2d.zip', [ScrollBar1.Position]);
      InitialDir := '.';
      if Execute then
        SoapAttachment.SaveToFile(FileName)
    finally
      Free
    end
  finally
    SoapAttachment.Free
  end
end;

procedure TUCCodeForm.btnCloseClick(Sender: TObject);
begin
  Close
end;

end.
